extern MyDouble biasCute;

#ifdef SPATIAL
// temporary functions for tests
bool wrongValues(MyInterval qxNaive, MyInterval qyNaive, MyInterval qzNaive,
                 MyInterval qx, MyInterval qy, MyInterval qz)
// qNaive is the widest estimation of q^bExp/|q|^{rExp}
// all other computed values have to be contained in it
{

    return (!subSet(qx, qxNaive) || !subSet(qy, qyNaive) || !subSet(qz, qzNaive));
}

void writeWrongValues(MyInterval qxNaive, MyInterval qyNaive, MyInterval qzNaive,
                      MyInterval qx, MyInterval qy, MyInterval qz)
{

    cout << "qxNaive = " << qxNaive << ", qxComputed = " << qx << endl
         << endl;
    cout << "qyNaive = " << qyNaive << ", qyComputed = " << qy << endl
         << endl;
    cout << "qzNaive = " << qzNaive << ", qzComputed = " << qz << endl
         << endl;
}

// end of block of temporary functions
#endif

#ifdef PLANAR

void testCuteCompareNaive(MyInterval x, MyInterval y, int rExp, int bExp)
//
{

    MyInterval qxCute, qyCute;
    MyInterval qx, qy;
    cuteCalculation(x, y, qxCute, qyCute, rExp, bExp);

    MyInterval r = sqrt(power(x, 2) + power(y, 2));
    qx = power(x, bExp) * power(r, -rExp);
    qy = power(y, bExp) * power(r, -rExp);

    if (!subSet(qxCute, qx))
    {
        cout << "BLAD! cute na X daje gorszy wynik!" << endl;
    }

    if (!subSet(qyCute, qy))
    {
        cout << "BLAD! cute na Y daje gorszy wynik!" << endl;
    }

    cout << "qx = " << qx << ", qxCute = " << qxCute << endl;
    cout << "qy = " << qy << ", qyCute = " << qyCute << endl;

    MyDouble d = diam(qx).rightBound();
    MyDouble dC = diam(qxCute).rightBound();
    cout << "zysk(%) = " << (1 - dC / d) * 100 << endl;
}

#endif

#ifdef SPATIAL
void testCute(MyInterval x, MyInterval y, MyInterval z,
              int rExp, int bExp, int p)
#endif
#ifdef PLANAR
    void testCute(MyInterval x, MyInterval y, int rExp, int bExp, int p)
#endif
// we test computation of q^bexp/r^{rexp}
//   by comparing cuteCalculation result with the evaluation on the lattice in cube x \times y \times z
//   where in each direction we divide in p-parts

{

    MyInterval qxCute, qyCute, qzCute, qxyCute;
    MyInterval qxCute3, qyCute3, qxCute2, qyCute2;
    MyInterval qx, qy, qz, qxy;
#ifdef SPATIAL
    MyInterval r = sqrt(power(x, 2) + power(y, 2) + power(z, 2));
#endif
#ifdef PLANAR
    MyInterval r = sqrt(power(x, 2) + power(y, 2));
#endif
    ///*
    biasCute = 0.0;
#ifdef SPATIAL
    cuteCalculation(x, y, z, qxCute, qyCute, qzCute, rExp, bExp);
#endif
#ifdef PLANAR
    cuteCalculation(x, y, qxCute, qyCute, rExp, bExp);

    cuteCalculation(x, y, qxCute3, qyCute3, 3, 1);
    cuteCalculation(x, y, qxCute2, qyCute2, 2, 1);
    cuteCalcMixed(x, y, qxyCute);
#endif
    biasCute = 1000.0;
#ifdef SPATIAL
    cuteCalculation(x, y, z, qx, qy, qz, rExp, bExp);
#endif
#ifdef PLANAR
    cuteCalculation(x, y, qx, qy, rExp, bExp);
    cuteCalcMixed(x, y, qxy);
#endif

    //*/

    ////////////////////////// in point ////////////////////

    MyInterval xStart = x.left();
    MyInterval yStart = y.left();
#ifdef SPATIAL
    MyInterval zStart = z.left();
#endif
    MyInterval xInside = xStart;
    MyInterval yInside = yStart;
#ifdef SPATIAL
    MyInterval zInside = zStart;
#endif
    MyInterval qxInside, qyInside, qzInside;
    MyInterval lenX = x.right() - x.left();
    MyInterval lenY = y.right() - y.left();
#ifdef SPATIAL
    MyInterval lenZ = z.right() - z.left();
#endif

    cout << "The qube :" << endl;
    cout << "x=" << x << endl;
    cout << "y=" << y << endl;
#ifdef SPATIAL
    cout << "z=" << z << endl;
#endif
    cout << "computation of q^" << bExp << "/r^" << rExp << endl;

    cout << "Dlugosci przedzialow:" << endl;
    cout << "lenX = " << lenX << endl;
    cout << "lenY = " << lenY << endl;
#ifdef SPATIAL
    cout << "lenZ = " << lenZ << endl;
#endif

    bool blad = false;

    cout << "Wartosci wewnatrz porownane z qCute:" << endl;
    for (int i = 0; i <= p; i++)
    {
        xInside = xStart + i * lenX / p;
        xInside = xInside.mid();
        if (!subSet(xInside, x))
            continue; // it may happen that if lenX is computed using doubles then for i=p this is no longer point in x !!!
        for (int j = 0; j <= p; j++)
        {
            yInside = yStart + j * lenY / p;
            yInside = yInside.mid();
            if (!subset(yInside, y))
                continue; // it may happen that if lenY is computed using doubles then for i=p this is no longer point in y !!!
#ifdef SPATIAL
            for (int k = 0; k <= p; k++)
            {
#endif

#ifdef SPATIAL
                zInside = zStart + k * lenZ / p;
                zInside = zInside.mid();
                if (!subSet(zInside, z))
                    continue; // it may happen that if lenZ is computed using doubles then for i=p this is no longer point in z !!!
#endif

#ifdef SPATIAL
                MyInterval r = sqrt(power(xInside, 2) + power(yInside, 2) + power(zInside, 2));
#endif

#ifdef PLANAR
                MyInterval r = sqrt(power(xInside, 2) + power(yInside, 2));
#endif
                MyInterval r3 = power(r, -rExp);

                MyInterval qxInside = power(xInside, bExp) * r3;
                MyInterval qyInside = power(yInside, bExp) * r3;
#ifdef SPATIAL
                MyInterval qzInside = power(zInside, bExp) * r3;
#endif

                MyInterval tempIntersect;

                if (!myIntersection(qxInside, qxCute, tempIntersect))
                {
                    blad = true;
                    cout << endl
                         << "BLAD! " << endl;
                    ///*
                    cout << "(i, j";
#ifdef SPATIAL
                    cout << "k";
#endif
                    cout << ") = (" << i << ", " << j;
#ifdef SPATIAL
                    cout << ", " << k;
#endif
                    cout << "):   qxInside = " << qxInside << ", qxCute = " << qxCute << ", qxNaive = " << qx << endl
                         << endl;
                    cout << "qxInside.left() - qxCute.left() =" << qxInside.left() - qxCute.left() << endl;
                    cout << "qxInside.right() - qxCute.right() =" << qxInside.right() - qxCute.right() << endl;

                    cout << "x = " << x << ", xInside = " << xInside << endl;
                    cout << "y = " << y << ", yInside = " << yInside << endl;

#ifdef SPATIAL
                    cout << "z = " << z << ", zInside = " << zInside << endl;
#endif
                }

                if (!myIntersection(qyInside, qyCute, tempIntersect))
                {
                    blad = true;
                    cout << endl
                         << "BLAD! " << endl;
                    ///*
                    cout << "(i, j";
#ifdef SPATIAL
                    cout << ", k";
#endif
                    cout << ") = (" << i << ", " << j;
#ifdef SPATIAL
                    cout << ", " << k;
#endif
                    cout << "):    qyInside = " << qyInside << ", qyCute = " << qyCute << ", qyNaive = " << qy << endl
                         << endl;
                    cout << "qyInside.left() - qyCute.left() =" << qyInside.left() - qyCute.left() << endl;
                    cout << "qyInside.right() - qyCute.right() =" << qyInside.right() - qyCute.right() << endl;

                    cout << "x = " << x << ", xInside = " << xInside << endl;
                    cout << "y = " << y << ", yInside = " << yInside << endl;
#ifdef SPATIAL
                    cout << "z = " << z << ", zInside = " << zInside << endl;
#endif
                }
#ifdef SPATIAL
                if (!myIntersection(qzInside, qzCute, tempIntersect))
                {
                    blad = true;
                    cout << endl
                         << "BLAD! " << endl;
                    ///*
                    cout << "(i, j, k) = (" << i << ", " << j << ", " << k
                         << "):    qzInside = " << qzInside << ", qzCute = " << qzCute << ", qzNaive = " << qz << endl
                         << endl;
                    cout << "qzInside - qzCute =" << qyInside - qyCute << endl;
                    cout << "x = " << x << ", xInside = " << xInside << endl;
                    cout << "y = " << y << ", yInside = " << yInside << endl;
                    cout << "z = " << z << ", zInside = " << zInside << endl;
                }
#endif
#ifdef SPATIAL
            } // for k
#endif
        } // for j
    }     // for i
    ////////////////////////////////////////////////////////
    if (!blad)
        cout << "Wartosci w punktach sa maja niepuste przeciecie z qCute" << endl;

    if (!subSet(qxCute, qx))
    {
        cout << "BLAD! cute na X daje gorszy wynik!" << endl;
    }

    if (!subSet(qyCute, qy))
    {
        cout << "BLAD! cute na Y daje gorszy wynik!" << endl;
    }

    if (!subSet(qxyCute, qxy))
    {
        cout << "BLAD! cute na XY daje gorszy wynik!" << endl;
    }

#ifdef SPATIAL
    if (!subSet(qzCute, qz))
    {
        cout << "BLAD! cute na Z daje gorszy wynik!" << endl;
    }
#endif

    cout << "qxy = " << qxy << ", qxyCute = " << qxyCute << ", qx3*qy2 = " << qxCute3 * qyCute2 << endl
         << endl;

    cout << "qx = " << qx << ", qxCute = " << qxCute << endl;
    cout << "qy = " << qy << ", qyCute = " << qyCute << endl;
#ifdef SPATIAL
    cout << "qz = " << qz << ", qzCute = " << qzCute << endl;
#endif
}

#ifdef SPATIAL
void superTestCute()
{
    /*  MyInterval x = MyInterval(-0.1, 0.2);
    MyInterval y = MyInterval(0.1, 0.2);
    MyInterval z = MyInterval(-0.1, 0.2); */

    MyInterval x = MyInterval(0.1, 0.2);
    MyInterval y = MyInterval(0.1, 0.2);
    MyInterval z = MyInterval(0.1, 0.2);
    int rExp = 5;
    int bExp = 3;

    testCute(x, y, z, rExp, bExp, 100);
}

#endif

#ifdef PLANAR
void superTestCute()
{
    // intervals x and y cannot be both singular!!!
    MyInterval x = MyInterval(-0.2, 0.02);
    MyInterval y = MyInterval(-0.2, -0.05);
    if (isSingular(x) && isSingular(y))
    {
        cout << "intervals x and y cannot be both singular!!!";
        exit(1);
    }
    int rExp = 5;
    int bExp = 3;

    testCute(x, y, rExp, bExp, 10);
}

#endif
